/* --- Generated by genom 2.99.44. Do not edit -------------------------- */
/*
 * Copyright (c) 2019,2023-2025 LAAS/CNRS
 * All rights reserved.
 *
 * Redistribution  and  use  in  source  and binary  forms,  with  or  without
 * modification, are permitted provided that the following conditions are met:
 *
 *   1. Redistributions of  source  code must retain the  above copyright
 *      notice and this list of conditions.
 *   2. Redistributions in binary form must reproduce the above copyright
 *      notice and  this list of  conditions in the  documentation and/or
 *      other materials provided with the distribution.
 *
 * THE SOFTWARE  IS PROVIDED "AS IS"  AND THE AUTHOR  DISCLAIMS ALL WARRANTIES
 * WITH  REGARD   TO  THIS  SOFTWARE  INCLUDING  ALL   IMPLIED  WARRANTIES  OF
 * MERCHANTABILITY AND  FITNESS.  IN NO EVENT  SHALL THE AUTHOR  BE LIABLE FOR
 * ANY  SPECIAL, DIRECT,  INDIRECT, OR  CONSEQUENTIAL DAMAGES  OR  ANY DAMAGES
 * WHATSOEVER  RESULTING FROM  LOSS OF  USE, DATA  OR PROFITS,  WHETHER  IN AN
 * ACTION OF CONTRACT, NEGLIGENCE OR  OTHER TORTIOUS ACTION, ARISING OUT OF OR
 * IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 *
 *                                             Martin Jacquet - September 2022
 */


#ifndef H_REALSENSE_CLIENT
#define H_REALSENSE_CLIENT


#include "genom3/c/client.h"


/* --- Interface types ----------------------------------------------------- */





#ifndef _genom_state_stats_c_type
# define _genom_state_stats_c_type
typedef struct genom_state_stats genom_state_stats;
#endif /* _genom_state_stats_c_type */

#ifndef _genom_state_stats_definition_c_type
# define _genom_state_stats_definition_c_type
struct genom_state_stats {
 float last;
 float max;
 float avg;
};
#endif /* _genom_state_stats_definition_c_type */

#include <stdint.h>

#ifndef _genom_state_rusage_c_type
# define _genom_state_rusage_c_type
typedef struct genom_state_rusage genom_state_rusage;
#endif /* _genom_state_rusage_c_type */

#ifndef _genom_state_rusage_definition_c_type
# define _genom_state_rusage_definition_c_type
struct genom_state_rusage {
 uint32_t cycles;
 genom_state_stats timings;
 genom_state_stats load;
};
#endif /* _genom_state_rusage_definition_c_type */

#include <stdint.h>

#ifndef _genom_state_activity_c_type
# define _genom_state_activity_c_type
typedef struct genom_state_activity genom_state_activity;
#endif /* _genom_state_activity_c_type */

#ifndef _genom_state_activity_definition_c_type
# define _genom_state_activity_definition_c_type
struct genom_state_activity {
 uint32_t id;
 char name[64];
};
#endif /* _genom_state_activity_definition_c_type */

#include <stdint.h>
#include "genom3/c/idlsequence.h"

#ifndef _sequence_genom_state_activity_c_type
# define _sequence_genom_state_activity_c_type
typedef struct sequence_genom_state_activity {
  uint32_t _maximum, _length;
  genom_state_activity *_buffer;
  void (*_release)(void *_buffer);
} sequence_genom_state_activity;
#endif /* _sequence_genom_state_activity_c_type */

#include <stdint.h>
#include "genom3/c/idlsequence.h"

#ifndef _genom_state_task_c_type
# define _genom_state_task_c_type
typedef struct genom_state_task genom_state_task;
#endif /* _genom_state_task_c_type */

#ifndef _sequence_genom_state_activity_c_type
# define _sequence_genom_state_activity_c_type
typedef struct sequence_genom_state_activity {
  uint32_t _maximum, _length;
  genom_state_activity *_buffer;
  void (*_release)(void *_buffer);
} sequence_genom_state_activity;
#endif /* _sequence_genom_state_activity_c_type */

#ifndef _genom_state_task_definition_c_type
# define _genom_state_task_definition_c_type
struct genom_state_task {
 char name[64];
 genom_state_rusage rusage;
 sequence_genom_state_activity activity;
};
#endif /* _genom_state_task_definition_c_type */

#include <stdint.h>
#include "genom3/c/idlsequence.h"

#ifndef _sequence_genom_state_task_c_type
# define _sequence_genom_state_task_c_type
typedef struct sequence_genom_state_task {
  uint32_t _maximum, _length;
  genom_state_task *_buffer;
  void (*_release)(void *_buffer);
} sequence_genom_state_task;
#endif /* _sequence_genom_state_task_c_type */




#include <stdint.h>
#include "genom3/c/idlsequence.h"

#ifndef _genom_state_component_c_type
# define _genom_state_component_c_type
typedef struct genom_state_component genom_state_component;
#endif /* _genom_state_component_c_type */

#ifndef _sequence_genom_state_task_c_type
# define _sequence_genom_state_task_c_type
typedef struct sequence_genom_state_task {
  uint32_t _maximum, _length;
  genom_state_task *_buffer;
  void (*_release)(void *_buffer);
} sequence_genom_state_task;
#endif /* _sequence_genom_state_task_c_type */

#ifndef _genom_state_component_definition_c_type
# define _genom_state_component_definition_c_type
struct genom_state_component {
 sequence_genom_state_task task;
 char digest[33];
 char date[31];
 char version[32];
};
#endif /* _genom_state_component_definition_c_type */


#include <stdint.h>

#ifndef _or_time_ts_c_type
# define _or_time_ts_c_type
typedef struct or_time_ts or_time_ts;
#endif /* _or_time_ts_c_type */

#ifndef _or_time_ts_definition_c_type
# define _or_time_ts_definition_c_type
struct or_time_ts {
 int32_t sec;
 int32_t nsec;
};
#endif /* _or_time_ts_definition_c_type */

#include <stdint.h>

#ifndef _or_sensor_pixmap_roi_c_type
# define _or_sensor_pixmap_roi_c_type
typedef struct or_sensor_pixmap_roi or_sensor_pixmap_roi;
#endif /* _or_sensor_pixmap_roi_c_type */

#ifndef _or_sensor_pixmap_roi_definition_c_type
# define _or_sensor_pixmap_roi_definition_c_type
struct or_sensor_pixmap_roi {
 uint32_t subsx;
 uint32_t subsy;
 uint32_t x;
 uint32_t y;
 uint32_t width;
 uint32_t height;
};
#endif /* _or_sensor_pixmap_roi_definition_c_type */

#include <stdbool.h>

#ifndef _optional_or_sensor_pixmap_roi_c_type
# define _optional_or_sensor_pixmap_roi_c_type
typedef struct optional_or_sensor_pixmap_roi {
  bool _present;
  or_sensor_pixmap_roi _value;
} optional_or_sensor_pixmap_roi;
#endif /* _optional_or_sensor_pixmap_roi_c_type */

#include <stdint.h>

#ifndef _or_image_distortion_model_c_type
# define _or_image_distortion_model_c_type
typedef uint32_t or_image_distortion_model;
enum {
  or_image_R3T2 =	0
};
#endif /* _or_image_distortion_model_c_type */


#include <stdint.h>
#include "genom3/c/idlsequence.h"

#ifndef _sequence8_double_c_type
# define _sequence8_double_c_type
typedef struct sequence8_double {
  uint32_t _maximum, _length;
  double _buffer[8];
} sequence8_double;
#endif /* _sequence8_double_c_type */

#include <stdint.h>
#include "genom3/c/idlsequence.h"

#ifndef _or_image_distortion_c_type
# define _or_image_distortion_c_type
typedef struct or_image_distortion or_image_distortion;
#endif /* _or_image_distortion_c_type */

#ifndef _sequence8_double_c_type
# define _sequence8_double_c_type
typedef struct sequence8_double {
  uint32_t _maximum, _length;
  double _buffer[8];
} sequence8_double;
#endif /* _sequence8_double_c_type */

#ifndef _or_image_distortion_definition_c_type
# define _or_image_distortion_definition_c_type
struct or_image_distortion {
 or_image_distortion_model model;
 sequence8_double coeffs;
};
#endif /* _or_image_distortion_definition_c_type */

#include <stdbool.h>

#ifndef _optional_or_image_distortion_c_type
# define _optional_or_image_distortion_c_type
typedef struct optional_or_image_distortion {
  bool _present;
  or_image_distortion _value;
} optional_or_image_distortion;
#endif /* _optional_or_image_distortion_c_type */


#ifndef _or_image_intrinsic_c_type
# define _or_image_intrinsic_c_type
typedef struct or_image_intrinsic or_image_intrinsic;
#endif /* _or_image_intrinsic_c_type */

#ifndef _or_image_intrinsic_definition_c_type
# define _or_image_intrinsic_definition_c_type
struct or_image_intrinsic {
 double fx;
 double fy;
 double cx;
 double cy;
};
#endif /* _or_image_intrinsic_definition_c_type */

#include <stdbool.h>

#ifndef _optional_or_image_intrinsic_c_type
# define _optional_or_image_intrinsic_c_type
typedef struct optional_or_image_intrinsic {
  bool _present;
  or_image_intrinsic _value;
} optional_or_image_intrinsic;
#endif /* _optional_or_image_intrinsic_c_type */


#ifndef _or_t3d_pos_c_type
# define _or_t3d_pos_c_type
typedef struct or_t3d_pos or_t3d_pos;
#endif /* _or_t3d_pos_c_type */

#ifndef _or_t3d_pos_definition_c_type
# define _or_t3d_pos_definition_c_type
struct or_t3d_pos {
 double x;
 double y;
 double z;
};
#endif /* _or_t3d_pos_definition_c_type */


#ifndef _or_t3d_att_c_type
# define _or_t3d_att_c_type
typedef struct or_t3d_att or_t3d_att;
#endif /* _or_t3d_att_c_type */

#ifndef _or_t3d_att_definition_c_type
# define _or_t3d_att_definition_c_type
struct or_t3d_att {
 double qw;
 double qx;
 double qy;
 double qz;
};
#endif /* _or_t3d_att_definition_c_type */


#ifndef _or_image_extrinsic_c_type
# define _or_image_extrinsic_c_type
typedef struct or_image_extrinsic or_image_extrinsic;
#endif /* _or_image_extrinsic_c_type */

#ifndef _or_image_extrinsic_definition_c_type
# define _or_image_extrinsic_definition_c_type
struct or_image_extrinsic {
 or_t3d_pos T;
 or_t3d_att R;
};
#endif /* _or_image_extrinsic_definition_c_type */

#include <stdbool.h>

#ifndef _optional_or_image_extrinsic_c_type
# define _optional_or_image_extrinsic_c_type
typedef struct optional_or_image_extrinsic {
  bool _present;
  or_image_extrinsic _value;
} optional_or_image_extrinsic;
#endif /* _optional_or_image_extrinsic_c_type */

#include <stdint.h>
#include <stdbool.h>

#ifndef _or_image_info_c_type
# define _or_image_info_c_type
typedef struct or_image_info or_image_info;
#endif /* _or_image_info_c_type */

#ifndef _optional_or_sensor_pixmap_roi_c_type
# define _optional_or_sensor_pixmap_roi_c_type
typedef struct optional_or_sensor_pixmap_roi {
  bool _present;
  or_sensor_pixmap_roi _value;
} optional_or_sensor_pixmap_roi;
#endif /* _optional_or_sensor_pixmap_roi_c_type */

#ifndef _optional_or_image_distortion_c_type
# define _optional_or_image_distortion_c_type
typedef struct optional_or_image_distortion {
  bool _present;
  or_image_distortion _value;
} optional_or_image_distortion;
#endif /* _optional_or_image_distortion_c_type */

#ifndef _optional_or_image_intrinsic_c_type
# define _optional_or_image_intrinsic_c_type
typedef struct optional_or_image_intrinsic {
  bool _present;
  or_image_intrinsic _value;
} optional_or_image_intrinsic;
#endif /* _optional_or_image_intrinsic_c_type */

#ifndef _optional_or_image_extrinsic_c_type
# define _optional_or_image_extrinsic_c_type
typedef struct optional_or_image_extrinsic {
  bool _present;
  or_image_extrinsic _value;
} optional_or_image_extrinsic;
#endif /* _optional_or_image_extrinsic_c_type */

#ifndef _or_image_info_definition_c_type
# define _or_image_info_definition_c_type
struct or_image_info {
 uint32_t seq;
 optional_or_sensor_pixmap_roi roi;
 optional_or_image_distortion distortion;
 optional_or_image_intrinsic intrinsics;
 optional_or_image_extrinsic extrinsics;
};
#endif /* _or_image_info_definition_c_type */

#include <stdint.h>

#ifndef _or_sensor_pixmap_encoding_c_type
# define _or_sensor_pixmap_encoding_c_type
typedef uint32_t or_sensor_pixmap_encoding;
enum {
  or_sensor_pixmap_ANY =	0,
  or_sensor_pixmap_MONO8 =	1,
  or_sensor_pixmap_RGB8 =	2,
  or_sensor_pixmap_BGR8 =	3,
  or_sensor_pixmap_RGBA8 =	4,
  or_sensor_pixmap_BGRA8 =	5,
  or_sensor_pixmap_MONO16 =	6,
  or_sensor_pixmap_Z32 =	7,
  or_sensor_pixmap_XYZ32 =	8,
  or_sensor_pixmap_JPEG =	9,
  or_sensor_pixmap_INVALID =	10
};
#endif /* _or_sensor_pixmap_encoding_c_type */


#include <stdint.h>
#include "genom3/c/idlsequence.h"

#ifndef _sequence_octet_c_type
# define _sequence_octet_c_type
typedef struct sequence_octet {
  uint32_t _maximum, _length;
  uint8_t *_buffer;
  void (*_release)(void *_buffer);
} sequence_octet;
#endif /* _sequence_octet_c_type */

#include <stdint.h>
#include "genom3/c/idlsequence.h"

#ifndef _or_sensor_pixmap_c_type
# define _or_sensor_pixmap_c_type
typedef struct or_sensor_pixmap or_sensor_pixmap;
#endif /* _or_sensor_pixmap_c_type */

#ifndef _sequence_octet_c_type
# define _sequence_octet_c_type
typedef struct sequence_octet {
  uint32_t _maximum, _length;
  uint8_t *_buffer;
  void (*_release)(void *_buffer);
} sequence_octet;
#endif /* _sequence_octet_c_type */

#ifndef _or_sensor_pixmap_definition_c_type
# define _or_sensor_pixmap_definition_c_type
struct or_sensor_pixmap {
 uint32_t seq;
 uint32_t width;
 uint32_t height;
 uint32_t stride;
 or_sensor_pixmap_encoding pixfmt;
 sequence_octet data;
};
#endif /* _or_sensor_pixmap_definition_c_type */


#ifndef _or_image_frame_c_type
# define _or_image_frame_c_type
typedef struct or_image_frame or_image_frame;
#endif /* _or_image_frame_c_type */

#ifndef _or_image_frame_definition_c_type
# define _or_image_frame_definition_c_type
struct or_image_frame {
 or_time_ts ts;
 or_image_info info;
 or_sensor_pixmap pixmap;
};
#endif /* _or_image_frame_definition_c_type */

#include <stdint.h>
#include "genom3/c/idlsequence.h"

#ifndef _sequence8_or_image_frame_c_type
# define _sequence8_or_image_frame_c_type
typedef struct sequence8_or_image_frame {
  uint32_t _maximum, _length;
  or_image_frame _buffer[8];
} sequence8_or_image_frame;
#endif /* _sequence8_or_image_frame_c_type */

#include <stdint.h>
#include "genom3/c/idlsequence.h"

#ifndef _sequence8_or_image_frame_c_type
# define _sequence8_or_image_frame_c_type
typedef struct sequence8_or_image_frame {
  uint32_t _maximum, _length;
  or_image_frame _buffer[8];
} sequence8_or_image_frame;
#endif /* _sequence8_or_image_frame_c_type */

#ifndef _or_image_frameset_c_type
# define _or_image_frameset_c_type
typedef sequence8_or_image_frame or_image_frameset;
#endif /* _or_image_frameset_c_type */


#ifndef _or_image_bank_c_type
# define _or_image_bank_c_type
typedef struct or_image_bank or_image_bank;
#endif /* _or_image_bank_c_type */

#ifndef _or_image_bank_definition_c_type
# define _or_image_bank_definition_c_type
struct or_image_bank {
 or_time_ts ts;
 or_image_frameset images;
};
#endif /* _or_image_bank_definition_c_type */


#include <stdbool.h>

#ifndef _optional_or_t3d_pos_c_type
# define _optional_or_t3d_pos_c_type
typedef struct optional_or_t3d_pos {
  bool _present;
  or_t3d_pos _value;
} optional_or_t3d_pos;
#endif /* _optional_or_t3d_pos_c_type */

#include <stdbool.h>

#ifndef _optional_or_t3d_att_c_type
# define _optional_or_t3d_att_c_type
typedef struct optional_or_t3d_att {
  bool _present;
  or_t3d_att _value;
} optional_or_t3d_att;
#endif /* _optional_or_t3d_att_c_type */


#ifndef _or_t3d_vel_c_type
# define _or_t3d_vel_c_type
typedef struct or_t3d_vel or_t3d_vel;
#endif /* _or_t3d_vel_c_type */

#ifndef _or_t3d_vel_definition_c_type
# define _or_t3d_vel_definition_c_type
struct or_t3d_vel {
 double vx;
 double vy;
 double vz;
};
#endif /* _or_t3d_vel_definition_c_type */

#include <stdbool.h>

#ifndef _optional_or_t3d_vel_c_type
# define _optional_or_t3d_vel_c_type
typedef struct optional_or_t3d_vel {
  bool _present;
  or_t3d_vel _value;
} optional_or_t3d_vel;
#endif /* _optional_or_t3d_vel_c_type */


#ifndef _or_t3d_avel_c_type
# define _or_t3d_avel_c_type
typedef struct or_t3d_avel or_t3d_avel;
#endif /* _or_t3d_avel_c_type */

#ifndef _or_t3d_avel_definition_c_type
# define _or_t3d_avel_definition_c_type
struct or_t3d_avel {
 double wx;
 double wy;
 double wz;
};
#endif /* _or_t3d_avel_definition_c_type */

#include <stdbool.h>

#ifndef _optional_or_t3d_avel_c_type
# define _optional_or_t3d_avel_c_type
typedef struct optional_or_t3d_avel {
  bool _present;
  or_t3d_avel _value;
} optional_or_t3d_avel;
#endif /* _optional_or_t3d_avel_c_type */


#ifndef _or_t3d_acc_c_type
# define _or_t3d_acc_c_type
typedef struct or_t3d_acc or_t3d_acc;
#endif /* _or_t3d_acc_c_type */

#ifndef _or_t3d_acc_definition_c_type
# define _or_t3d_acc_definition_c_type
struct or_t3d_acc {
 double ax;
 double ay;
 double az;
};
#endif /* _or_t3d_acc_definition_c_type */

#include <stdbool.h>

#ifndef _optional_or_t3d_acc_c_type
# define _optional_or_t3d_acc_c_type
typedef struct optional_or_t3d_acc {
  bool _present;
  or_t3d_acc _value;
} optional_or_t3d_acc;
#endif /* _optional_or_t3d_acc_c_type */


#ifndef _or_t3d_aacc_c_type
# define _or_t3d_aacc_c_type
typedef struct or_t3d_aacc or_t3d_aacc;
#endif /* _or_t3d_aacc_c_type */

#ifndef _or_t3d_aacc_definition_c_type
# define _or_t3d_aacc_definition_c_type
struct or_t3d_aacc {
 double awx;
 double awy;
 double awz;
};
#endif /* _or_t3d_aacc_definition_c_type */

#include <stdbool.h>

#ifndef _optional_or_t3d_aacc_c_type
# define _optional_or_t3d_aacc_c_type
typedef struct optional_or_t3d_aacc {
  bool _present;
  or_t3d_aacc _value;
} optional_or_t3d_aacc;
#endif /* _optional_or_t3d_aacc_c_type */



#ifndef _or_t3d_pos_cov_c_type
# define _or_t3d_pos_cov_c_type
typedef struct or_t3d_pos_cov or_t3d_pos_cov;
#endif /* _or_t3d_pos_cov_c_type */

#ifndef _or_t3d_pos_cov_definition_c_type
# define _or_t3d_pos_cov_definition_c_type
struct or_t3d_pos_cov {
 double cov[6];
};
#endif /* _or_t3d_pos_cov_definition_c_type */

#include <stdbool.h>

#ifndef _optional_or_t3d_pos_cov_c_type
# define _optional_or_t3d_pos_cov_c_type
typedef struct optional_or_t3d_pos_cov {
  bool _present;
  or_t3d_pos_cov _value;
} optional_or_t3d_pos_cov;
#endif /* _optional_or_t3d_pos_cov_c_type */



#ifndef _or_t3d_att_cov_c_type
# define _or_t3d_att_cov_c_type
typedef struct or_t3d_att_cov or_t3d_att_cov;
#endif /* _or_t3d_att_cov_c_type */

#ifndef _or_t3d_att_cov_definition_c_type
# define _or_t3d_att_cov_definition_c_type
struct or_t3d_att_cov {
 double cov[10];
};
#endif /* _or_t3d_att_cov_definition_c_type */

#include <stdbool.h>

#ifndef _optional_or_t3d_att_cov_c_type
# define _optional_or_t3d_att_cov_c_type
typedef struct optional_or_t3d_att_cov {
  bool _present;
  or_t3d_att_cov _value;
} optional_or_t3d_att_cov;
#endif /* _optional_or_t3d_att_cov_c_type */



#ifndef _or_t3d_att_pos_cov_c_type
# define _or_t3d_att_pos_cov_c_type
typedef struct or_t3d_att_pos_cov or_t3d_att_pos_cov;
#endif /* _or_t3d_att_pos_cov_c_type */

#ifndef _or_t3d_att_pos_cov_definition_c_type
# define _or_t3d_att_pos_cov_definition_c_type
struct or_t3d_att_pos_cov {
 double cov[12];
};
#endif /* _or_t3d_att_pos_cov_definition_c_type */

#include <stdbool.h>

#ifndef _optional_or_t3d_att_pos_cov_c_type
# define _optional_or_t3d_att_pos_cov_c_type
typedef struct optional_or_t3d_att_pos_cov {
  bool _present;
  or_t3d_att_pos_cov _value;
} optional_or_t3d_att_pos_cov;
#endif /* _optional_or_t3d_att_pos_cov_c_type */


#ifndef _or_t3d_vel_cov_c_type
# define _or_t3d_vel_cov_c_type
typedef struct or_t3d_vel_cov or_t3d_vel_cov;
#endif /* _or_t3d_vel_cov_c_type */

#ifndef _or_t3d_vel_cov_definition_c_type
# define _or_t3d_vel_cov_definition_c_type
struct or_t3d_vel_cov {
 double cov[6];
};
#endif /* _or_t3d_vel_cov_definition_c_type */

#include <stdbool.h>

#ifndef _optional_or_t3d_vel_cov_c_type
# define _optional_or_t3d_vel_cov_c_type
typedef struct optional_or_t3d_vel_cov {
  bool _present;
  or_t3d_vel_cov _value;
} optional_or_t3d_vel_cov;
#endif /* _optional_or_t3d_vel_cov_c_type */


#ifndef _or_t3d_avel_cov_c_type
# define _or_t3d_avel_cov_c_type
typedef struct or_t3d_avel_cov or_t3d_avel_cov;
#endif /* _or_t3d_avel_cov_c_type */

#ifndef _or_t3d_avel_cov_definition_c_type
# define _or_t3d_avel_cov_definition_c_type
struct or_t3d_avel_cov {
 double cov[6];
};
#endif /* _or_t3d_avel_cov_definition_c_type */

#include <stdbool.h>

#ifndef _optional_or_t3d_avel_cov_c_type
# define _optional_or_t3d_avel_cov_c_type
typedef struct optional_or_t3d_avel_cov {
  bool _present;
  or_t3d_avel_cov _value;
} optional_or_t3d_avel_cov;
#endif /* _optional_or_t3d_avel_cov_c_type */


#ifndef _or_t3d_acc_cov_c_type
# define _or_t3d_acc_cov_c_type
typedef struct or_t3d_acc_cov or_t3d_acc_cov;
#endif /* _or_t3d_acc_cov_c_type */

#ifndef _or_t3d_acc_cov_definition_c_type
# define _or_t3d_acc_cov_definition_c_type
struct or_t3d_acc_cov {
 double cov[6];
};
#endif /* _or_t3d_acc_cov_definition_c_type */

#include <stdbool.h>

#ifndef _optional_or_t3d_acc_cov_c_type
# define _optional_or_t3d_acc_cov_c_type
typedef struct optional_or_t3d_acc_cov {
  bool _present;
  or_t3d_acc_cov _value;
} optional_or_t3d_acc_cov;
#endif /* _optional_or_t3d_acc_cov_c_type */


#ifndef _or_t3d_aacc_cov_c_type
# define _or_t3d_aacc_cov_c_type
typedef struct or_t3d_aacc_cov or_t3d_aacc_cov;
#endif /* _or_t3d_aacc_cov_c_type */

#ifndef _or_t3d_aacc_cov_definition_c_type
# define _or_t3d_aacc_cov_definition_c_type
struct or_t3d_aacc_cov {
 double cov[6];
};
#endif /* _or_t3d_aacc_cov_definition_c_type */

#include <stdbool.h>

#ifndef _optional_or_t3d_aacc_cov_c_type
# define _optional_or_t3d_aacc_cov_c_type
typedef struct optional_or_t3d_aacc_cov {
  bool _present;
  or_t3d_aacc_cov _value;
} optional_or_t3d_aacc_cov;
#endif /* _optional_or_t3d_aacc_cov_c_type */

#include <stdbool.h>

#ifndef _or_pose_estimator_state_c_type
# define _or_pose_estimator_state_c_type
typedef struct or_pose_estimator_state or_pose_estimator_state;
#endif /* _or_pose_estimator_state_c_type */

#ifndef _optional_or_t3d_pos_c_type
# define _optional_or_t3d_pos_c_type
typedef struct optional_or_t3d_pos {
  bool _present;
  or_t3d_pos _value;
} optional_or_t3d_pos;
#endif /* _optional_or_t3d_pos_c_type */

#ifndef _optional_or_t3d_att_c_type
# define _optional_or_t3d_att_c_type
typedef struct optional_or_t3d_att {
  bool _present;
  or_t3d_att _value;
} optional_or_t3d_att;
#endif /* _optional_or_t3d_att_c_type */

#ifndef _optional_or_t3d_vel_c_type
# define _optional_or_t3d_vel_c_type
typedef struct optional_or_t3d_vel {
  bool _present;
  or_t3d_vel _value;
} optional_or_t3d_vel;
#endif /* _optional_or_t3d_vel_c_type */

#ifndef _optional_or_t3d_avel_c_type
# define _optional_or_t3d_avel_c_type
typedef struct optional_or_t3d_avel {
  bool _present;
  or_t3d_avel _value;
} optional_or_t3d_avel;
#endif /* _optional_or_t3d_avel_c_type */

#ifndef _optional_or_t3d_acc_c_type
# define _optional_or_t3d_acc_c_type
typedef struct optional_or_t3d_acc {
  bool _present;
  or_t3d_acc _value;
} optional_or_t3d_acc;
#endif /* _optional_or_t3d_acc_c_type */

#ifndef _optional_or_t3d_aacc_c_type
# define _optional_or_t3d_aacc_c_type
typedef struct optional_or_t3d_aacc {
  bool _present;
  or_t3d_aacc _value;
} optional_or_t3d_aacc;
#endif /* _optional_or_t3d_aacc_c_type */

#ifndef _optional_or_t3d_pos_cov_c_type
# define _optional_or_t3d_pos_cov_c_type
typedef struct optional_or_t3d_pos_cov {
  bool _present;
  or_t3d_pos_cov _value;
} optional_or_t3d_pos_cov;
#endif /* _optional_or_t3d_pos_cov_c_type */

#ifndef _optional_or_t3d_att_cov_c_type
# define _optional_or_t3d_att_cov_c_type
typedef struct optional_or_t3d_att_cov {
  bool _present;
  or_t3d_att_cov _value;
} optional_or_t3d_att_cov;
#endif /* _optional_or_t3d_att_cov_c_type */

#ifndef _optional_or_t3d_att_pos_cov_c_type
# define _optional_or_t3d_att_pos_cov_c_type
typedef struct optional_or_t3d_att_pos_cov {
  bool _present;
  or_t3d_att_pos_cov _value;
} optional_or_t3d_att_pos_cov;
#endif /* _optional_or_t3d_att_pos_cov_c_type */

#ifndef _optional_or_t3d_vel_cov_c_type
# define _optional_or_t3d_vel_cov_c_type
typedef struct optional_or_t3d_vel_cov {
  bool _present;
  or_t3d_vel_cov _value;
} optional_or_t3d_vel_cov;
#endif /* _optional_or_t3d_vel_cov_c_type */

#ifndef _optional_or_t3d_avel_cov_c_type
# define _optional_or_t3d_avel_cov_c_type
typedef struct optional_or_t3d_avel_cov {
  bool _present;
  or_t3d_avel_cov _value;
} optional_or_t3d_avel_cov;
#endif /* _optional_or_t3d_avel_cov_c_type */

#ifndef _optional_or_t3d_acc_cov_c_type
# define _optional_or_t3d_acc_cov_c_type
typedef struct optional_or_t3d_acc_cov {
  bool _present;
  or_t3d_acc_cov _value;
} optional_or_t3d_acc_cov;
#endif /* _optional_or_t3d_acc_cov_c_type */

#ifndef _optional_or_t3d_aacc_cov_c_type
# define _optional_or_t3d_aacc_cov_c_type
typedef struct optional_or_t3d_aacc_cov {
  bool _present;
  or_t3d_aacc_cov _value;
} optional_or_t3d_aacc_cov;
#endif /* _optional_or_t3d_aacc_cov_c_type */

#ifndef _or_pose_estimator_state_definition_c_type
# define _or_pose_estimator_state_definition_c_type
struct or_pose_estimator_state {
 or_time_ts ts;
 bool intrinsic;
 optional_or_t3d_pos pos;
 optional_or_t3d_att att;
 optional_or_t3d_vel vel;
 optional_or_t3d_avel avel;
 optional_or_t3d_acc acc;
 optional_or_t3d_aacc aacc;
 optional_or_t3d_pos_cov pos_cov;
 optional_or_t3d_att_cov att_cov;
 optional_or_t3d_att_pos_cov att_pos_cov;
 optional_or_t3d_vel_cov vel_cov;
 optional_or_t3d_avel_cov avel_cov;
 optional_or_t3d_acc_cov acc_cov;
 optional_or_t3d_aacc_cov aacc_cov;
};
#endif /* _or_pose_estimator_state_definition_c_type */


#ifndef _genom_incompatible_digest_client_digest_c_type
# define _genom_incompatible_digest_client_digest_c_type
typedef struct genom_incompatible_digest_client_digest genom_incompatible_digest_client_digest;
#endif /* _genom_incompatible_digest_client_digest_c_type */

#ifndef _genom_incompatible_digest_client_digest_definition_c_type
# define _genom_incompatible_digest_client_digest_definition_c_type
struct genom_incompatible_digest_client_digest {
 char version[32];
 char date[32];
};
#endif /* _genom_incompatible_digest_client_digest_definition_c_type */


#ifndef _genom_incompatible_digest_server_digest_c_type
# define _genom_incompatible_digest_server_digest_c_type
typedef struct genom_incompatible_digest_server_digest genom_incompatible_digest_server_digest;
#endif /* _genom_incompatible_digest_server_digest_c_type */

#ifndef _genom_incompatible_digest_server_digest_definition_c_type
# define _genom_incompatible_digest_server_digest_definition_c_type
struct genom_incompatible_digest_server_digest {
 char version[32];
 char date[32];
};
#endif /* _genom_incompatible_digest_server_digest_definition_c_type */

#include "genom3/c/context.h"

#ifndef _genom_incompatible_digest_c_type
# define _genom_incompatible_digest_c_type
#include "genom3/c/exception.h"
const char genom_extern_weak genom_incompatible_digest_id[] = "::genom::incompatible_digest";
typedef struct genom_incompatible_digest_detail genom_incompatible_digest_detail;
#endif /* _genom_incompatible_digest_c_type */

#ifndef _genom_incompatible_digest_definition_c_type
# define _genom_incompatible_digest_definition_c_type
struct genom_incompatible_digest_detail {
 genom_incompatible_digest_client_digest client;
 genom_incompatible_digest_server_digest server;
};
static inline genom_event
genom_incompatible_digest(const genom_incompatible_digest_detail *d, genom_context self) {
 return self->raise(genom_incompatible_digest_id, d, sizeof(*d), self);
}
#endif /* _genom_incompatible_digest_definition_c_type */


#include "genom3/c/context.h"

#ifndef _genom_bad_transition_c_type
# define _genom_bad_transition_c_type
#include "genom3/c/exception.h"
const char genom_extern_weak genom_bad_transition_id[] = "::genom::bad_transition";
typedef struct genom_bad_transition_detail genom_bad_transition_detail;
#endif /* _genom_bad_transition_c_type */

#ifndef _genom_bad_transition_definition_c_type
# define _genom_bad_transition_definition_c_type
struct genom_bad_transition_detail {
 char from[128];
 char to[128];
};
static inline genom_event
genom_bad_transition(const genom_bad_transition_detail *d, genom_context self) {
 return self->raise(genom_bad_transition_id, d, sizeof(*d), self);
}
#endif /* _genom_bad_transition_definition_c_type */

#include "genom3/c/context.h"

#ifndef _genom_interrupted_c_type
# define _genom_interrupted_c_type
#include "genom3/c/exception.h"
const char genom_extern_weak genom_interrupted_id[] = "::genom::interrupted";
typedef struct genom_interrupted_detail genom_interrupted_detail;
#endif /* _genom_interrupted_c_type */

#ifndef _genom_interrupted_definition_c_type
# define _genom_interrupted_definition_c_type
struct genom_interrupted_detail {
 char by[128];
};
static inline genom_event
genom_interrupted(const genom_interrupted_detail *d, genom_context self) {
 return self->raise(genom_interrupted_id, d, sizeof(*d), self);
}
#endif /* _genom_interrupted_definition_c_type */

#include "genom3/c/context.h"

#ifndef _genom_serialization_c_type
# define _genom_serialization_c_type
#include "genom3/c/exception.h"
const char genom_extern_weak genom_serialization_id[] = "::genom::serialization";
typedef void genom_serialization_detail;
#endif /* _genom_serialization_c_type */

#ifndef _genom_serialization_definition_c_type
# define _genom_serialization_definition_c_type
static inline genom_event
genom_serialization(genom_context self) {
 return self->raise(genom_serialization_id, NULL, 0, self);
}
#endif /* _genom_serialization_definition_c_type */

#include "genom3/c/context.h"

#ifndef _genom_too_many_activities_c_type
# define _genom_too_many_activities_c_type
#include "genom3/c/exception.h"
const char genom_extern_weak genom_too_many_activities_id[] = "::genom::too_many_activities";
typedef void genom_too_many_activities_detail;
#endif /* _genom_too_many_activities_c_type */

#ifndef _genom_too_many_activities_definition_c_type
# define _genom_too_many_activities_definition_c_type
static inline genom_event
genom_too_many_activities(genom_context self) {
 return self->raise(genom_too_many_activities_id, NULL, 0, self);
}
#endif /* _genom_too_many_activities_definition_c_type */

#include "genom3/c/context.h"

#ifndef _genom_disallowed_c_type
# define _genom_disallowed_c_type
#include "genom3/c/exception.h"
const char genom_extern_weak genom_disallowed_id[] = "::genom::disallowed";
typedef void genom_disallowed_detail;
#endif /* _genom_disallowed_c_type */

#ifndef _genom_disallowed_definition_c_type
# define _genom_disallowed_definition_c_type
static inline genom_event
genom_disallowed(genom_context self) {
 return self->raise(genom_disallowed_id, NULL, 0, self);
}
#endif /* _genom_disallowed_definition_c_type */


#include "genom3/c/context.h"

#ifndef _genom_mwerr_c_type
# define _genom_mwerr_c_type
#include "genom3/c/exception.h"
const char genom_extern_weak genom_mwerr_id[] = "::genom::mwerr";
typedef struct genom_mwerr_detail genom_mwerr_detail;
#endif /* _genom_mwerr_c_type */

#ifndef _genom_mwerr_definition_c_type
# define _genom_mwerr_definition_c_type
struct genom_mwerr_detail {
 char what[256];
};
static inline genom_event
genom_mwerr(const genom_mwerr_detail *d, genom_context self) {
 return self->raise(genom_mwerr_id, d, sizeof(*d), self);
}
#endif /* _genom_mwerr_definition_c_type */

#include "genom3/c/context.h"

#ifndef _genom_no_such_activity_c_type
# define _genom_no_such_activity_c_type
#include "genom3/c/exception.h"
const char genom_extern_weak genom_no_such_activity_id[] = "::genom::no_such_activity";
typedef void genom_no_such_activity_detail;
#endif /* _genom_no_such_activity_c_type */

#ifndef _genom_no_such_activity_definition_c_type
# define _genom_no_such_activity_definition_c_type
static inline genom_event
genom_no_such_activity(genom_context self) {
 return self->raise(genom_no_such_activity_id, NULL, 0, self);
}
#endif /* _genom_no_such_activity_definition_c_type */

#include "genom3/c/context.h"

#ifndef _genom_no_such_inport_c_type
# define _genom_no_such_inport_c_type
#include "genom3/c/exception.h"
const char genom_extern_weak genom_no_such_inport_id[] = "::genom::no_such_inport";
typedef void genom_no_such_inport_detail;
#endif /* _genom_no_such_inport_c_type */

#ifndef _genom_no_such_inport_definition_c_type
# define _genom_no_such_inport_definition_c_type
static inline genom_event
genom_no_such_inport(genom_context self) {
 return self->raise(genom_no_such_inport_id, NULL, 0, self);
}
#endif /* _genom_no_such_inport_definition_c_type */

#include "genom3/c/context.h"

#ifndef _genom_no_such_outport_c_type
# define _genom_no_such_outport_c_type
#include "genom3/c/exception.h"
const char genom_extern_weak genom_no_such_outport_id[] = "::genom::no_such_outport";
typedef void genom_no_such_outport_detail;
#endif /* _genom_no_such_outport_c_type */

#ifndef _genom_no_such_outport_definition_c_type
# define _genom_no_such_outport_definition_c_type
static inline genom_event
genom_no_such_outport(genom_context self) {
 return self->raise(genom_no_such_outport_id, NULL, 0, self);
}
#endif /* _genom_no_such_outport_definition_c_type */

#include "genom3/c/context.h"

#ifndef _genom_port_io_c_type
# define _genom_port_io_c_type
#include "genom3/c/exception.h"
const char genom_extern_weak genom_port_io_id[] = "::genom::port_io";
typedef void genom_port_io_detail;
#endif /* _genom_port_io_c_type */

#ifndef _genom_port_io_definition_c_type
# define _genom_port_io_definition_c_type
static inline genom_event
genom_port_io(genom_context self) {
 return self->raise(genom_port_io_id, NULL, 0, self);
}
#endif /* _genom_port_io_definition_c_type */

#include "genom3/c/context.h"

#ifndef _genom_no_such_remote_c_type
# define _genom_no_such_remote_c_type
#include "genom3/c/exception.h"
const char genom_extern_weak genom_no_such_remote_id[] = "::genom::no_such_remote";
typedef void genom_no_such_remote_detail;
#endif /* _genom_no_such_remote_c_type */

#ifndef _genom_no_such_remote_definition_c_type
# define _genom_no_such_remote_definition_c_type
static inline genom_event
genom_no_such_remote(genom_context self) {
 return self->raise(genom_no_such_remote_id, NULL, 0, self);
}
#endif /* _genom_no_such_remote_definition_c_type */

#include "genom3/c/context.h"

#ifndef _genom_no_such_service_c_type
# define _genom_no_such_service_c_type
#include "genom3/c/exception.h"
const char genom_extern_weak genom_no_such_service_id[] = "::genom::no_such_service";
typedef void genom_no_such_service_detail;
#endif /* _genom_no_such_service_c_type */

#ifndef _genom_no_such_service_definition_c_type
# define _genom_no_such_service_definition_c_type
static inline genom_event
genom_no_such_service(genom_context self) {
 return self->raise(genom_no_such_service_id, NULL, 0, self);
}
#endif /* _genom_no_such_service_definition_c_type */

#include "genom3/c/context.h"

#ifndef _genom_remote_io_c_type
# define _genom_remote_io_c_type
#include "genom3/c/exception.h"
const char genom_extern_weak genom_remote_io_id[] = "::genom::remote_io";
typedef void genom_remote_io_detail;
#endif /* _genom_remote_io_c_type */

#ifndef _genom_remote_io_definition_c_type
# define _genom_remote_io_definition_c_type
static inline genom_event
genom_remote_io(genom_context self) {
 return self->raise(genom_remote_io_id, NULL, 0, self);
}
#endif /* _genom_remote_io_definition_c_type */


#include "genom3/c/context.h"

#ifndef _camera_einval_c_type
# define _camera_einval_c_type
#include "genom3/c/exception.h"
const char genom_extern_weak camera_einval_id[] = "::camera::einval";
typedef struct camera_einval_detail camera_einval_detail;
#endif /* _camera_einval_c_type */

#ifndef _camera_einval_definition_c_type
# define _camera_einval_definition_c_type
struct camera_einval_detail {
 char what[128];
};
static inline genom_event
camera_einval(const camera_einval_detail *d, genom_context self) {
 return self->raise(camera_einval_id, d, sizeof(*d), self);
}
#endif /* _camera_einval_definition_c_type */


#include "genom3/c/context.h"

#ifndef _realsense_e_rs_c_type
# define _realsense_e_rs_c_type
#include "genom3/c/exception.h"
const char genom_extern_weak realsense_e_rs_id[] = "::realsense::e_rs";
typedef struct realsense_e_rs_detail realsense_e_rs_detail;
#endif /* _realsense_e_rs_c_type */

#ifndef _realsense_e_rs_definition_c_type
# define _realsense_e_rs_definition_c_type
struct realsense_e_rs_detail {
 char what[128];
};
static inline genom_event
realsense_e_rs(const realsense_e_rs_detail *d, genom_context self) {
 return self->raise(realsense_e_rs_id, d, sizeof(*d), self);
}
#endif /* _realsense_e_rs_definition_c_type */


#include <stdint.h>

#ifndef _realsense_stream_c_type
# define _realsense_stream_c_type
typedef uint32_t realsense_stream;
enum {
  realsense_STREAM_ANY =	0,
  realsense_STREAM_COLOR =	1,
  realsense_STREAM_INFRARED =	2,
  realsense_STREAM_DEPTH =	3,
  realsense_STREAM_GYRO =	4,
  realsense_STREAM_ACCEL =	5,
  realsense_STREAM_INVALID =	6
};
#endif /* _realsense_stream_c_type */

#include <stdint.h>
#include "genom3/c/idlsequence.h"

#ifndef _sequence16_realsense_stream_c_type
# define _sequence16_realsense_stream_c_type
typedef struct sequence16_realsense_stream {
  uint32_t _maximum, _length;
  realsense_stream _buffer[16];
} sequence16_realsense_stream;
#endif /* _sequence16_realsense_stream_c_type */

#include <stdint.h>
#include "genom3/c/idlsequence.h"

#ifndef _sequence16_long_c_type
# define _sequence16_long_c_type
typedef struct sequence16_long {
  uint32_t _maximum, _length;
  int32_t _buffer[16];
} sequence16_long;
#endif /* _sequence16_long_c_type */

#include <stdint.h>
#include "genom3/c/idlsequence.h"

#ifndef _sequence16_or_sensor_pixmap_encoding_c_type
# define _sequence16_or_sensor_pixmap_encoding_c_type
typedef struct sequence16_or_sensor_pixmap_encoding {
  uint32_t _maximum, _length;
  or_sensor_pixmap_encoding _buffer[16];
} sequence16_or_sensor_pixmap_encoding;
#endif /* _sequence16_or_sensor_pixmap_encoding_c_type */

#include "genom3/c/context.h"

#ifndef _realsense_einval_c_type
# define _realsense_einval_c_type
#include "genom3/c/exception.h"
const char genom_extern_weak realsense_einval_id[] = "::realsense::einval";
typedef void realsense_einval_detail;
#endif /* _realsense_einval_c_type */

#ifndef _realsense_einval_definition_c_type
# define _realsense_einval_definition_c_type
static inline genom_event
realsense_einval(genom_context self) {
 return self->raise(realsense_einval_id, NULL, 0, self);
}
#endif /* _realsense_einval_definition_c_type */

#include <stdint.h>

#ifndef _realsense_video_size_c_type
# define _realsense_video_size_c_type
typedef struct realsense_video_size realsense_video_size;
#endif /* _realsense_video_size_c_type */

#ifndef _realsense_video_size_definition_c_type
# define _realsense_video_size_definition_c_type
struct realsense_video_size {
 int32_t width;
 int32_t height;
};
#endif /* _realsense_video_size_definition_c_type */

#include <stdint.h>
#include "genom3/c/idlsequence.h"

#ifndef _sequence16_realsense_video_size_c_type
# define _sequence16_realsense_video_size_c_type
typedef struct sequence16_realsense_video_size {
  uint32_t _maximum, _length;
  realsense_video_size _buffer[16];
} sequence16_realsense_video_size;
#endif /* _sequence16_realsense_video_size_c_type */




/* --- Service input and output structures --------------------------------- */


/* input of abort_activity */
struct genom_realsense_abort_activity_input {
  uint32_t activity;
};

/* output of abort_activity */
struct genom_realsense_abort_activity_output {
};


/* input of connect_port */
struct genom_realsense_connect_port_input {
  char local[128];
  char remote[128];
};

/* output of connect_port */
struct genom_realsense_connect_port_output {
};


/* input of connect_service */
struct genom_realsense_connect_service_input {
  char local[128];
  char remote[128];
};

/* output of connect_service */
struct genom_realsense_connect_service_output {
};


/* input of kill */
struct genom_realsense_kill_input {
};

/* output of kill */
struct genom_realsense_kill_output {
};


/* input of publish */
struct genom_realsense_publish_input {
  char slot[16];
  char bank[16];
  uint8_t index;
};

/* output of publish */
struct genom_realsense_publish_output {
};


/* input of unpublish */
struct genom_realsense_unpublish_input {
  char bank[16];
  uint8_t index;
};

/* output of unpublish */
struct genom_realsense_unpublish_output {
};


/* input of jpeg */
struct genom_realsense_jpeg_input {
  char input[16];
  uint16_t quality;
  char output[16];
};

/* output of jpeg */
struct genom_realsense_jpeg_output {
};


/* input of record_mpeg */
struct genom_realsense_record_mpeg_input {
  char input[16];
  uint16_t width;
  uint16_t height;
  uint16_t fps;
  char output[128];
};

/* output of record_mpeg */
struct genom_realsense_record_mpeg_output {
};


/* input of cancel */
struct genom_realsense_cancel_input {
  char slot[16];
};

/* output of cancel */
struct genom_realsense_cancel_output {
};


/* input of status */
struct genom_realsense_status_input {
  char slot[16];
};

/* output of status */
struct genom_realsense_status_output {
};


/* input of get_imu_noise */
struct genom_realsense_get_imu_noise_input {
};

/* output of get_imu_noise */
struct genom_realsense_get_imu_noise_output {
  double gstddev[3];
  double astddev[3];
};


/* input of set_imu_noise */
struct genom_realsense_set_imu_noise_input {
  double gstddev[3];
  double astddev[3];
};

/* output of set_imu_noise */
struct genom_realsense_set_imu_noise_output {
};


/* input of get_streams */
struct genom_realsense_get_streams_input {
};

/* output of get_streams */
struct genom_realsense_get_streams_output {
  sequence16_realsense_stream streams;
};


/* input of get_stream_indices */
struct genom_realsense_get_stream_indices_input {
  realsense_stream type;
};

/* output of get_stream_indices */
struct genom_realsense_get_stream_indices_output {
  sequence16_long indices;
};


/* input of get_stream_fps */
struct genom_realsense_get_stream_fps_input {
  realsense_stream type;
};

/* output of get_stream_fps */
struct genom_realsense_get_stream_fps_output {
  sequence16_long fps;
};


/* input of get_video_stream_formats */
struct genom_realsense_get_video_stream_formats_input {
  realsense_stream type;
};

/* output of get_video_stream_formats */
struct genom_realsense_get_video_stream_formats_output {
  sequence16_or_sensor_pixmap_encoding format;
};


/* input of get_depth_stream_formats */
struct genom_realsense_get_depth_stream_formats_input {
  realsense_stream type;
};

/* output of get_depth_stream_formats */
struct genom_realsense_get_depth_stream_formats_output {
  sequence16_or_sensor_pixmap_encoding format;
};


/* input of get_video_stream_sizes */
struct genom_realsense_get_video_stream_sizes_input {
  realsense_stream type;
};

/* output of get_video_stream_sizes */
struct genom_realsense_get_video_stream_sizes_output {
  sequence16_realsense_video_size sizes;
};


/* input of get_depth_stream_sizes */
struct genom_realsense_get_depth_stream_sizes_input {
  realsense_stream type;
};

/* output of get_depth_stream_sizes */
struct genom_realsense_get_depth_stream_sizes_output {
  sequence16_realsense_video_size sizes;
};


/* input of stream_video */
struct genom_realsense_stream_video_input {
  realsense_stream type;
  int16_t index;
  int16_t width;
  int16_t height;
  or_sensor_pixmap_encoding format;
  int16_t fps;
  char name[16];
};

/* output of stream_video */
struct genom_realsense_stream_video_output {
};


/* input of stream_depth */
struct genom_realsense_stream_depth_input {
  realsense_stream type;
  int16_t index;
  int16_t width;
  int16_t height;
  or_sensor_pixmap_encoding format;
  int16_t fps;
  char name[16];
};

/* output of stream_depth */
struct genom_realsense_stream_depth_output {
};


/* input of stream_motion */
struct genom_realsense_stream_motion_input {
  realsense_stream type;
  int16_t index;
  int16_t fps;
};

/* output of stream_motion */
struct genom_realsense_stream_motion_output {
};



#ifdef __cplusplus
extern "C" {
#endif

/* --- Services ------------------------------------------------------------ */

genom_client		genom_realsense_client_init(int argc, char *argv[],
                                genom_event *ex, const void **exdetail);
void			genom_realsense_client_fini(genom_client h);
genom_context		genom_realsense_client_context(genom_client h);
const char *		genom_realsense_client_instance(genom_client h);
int			genom_realsense_client_eventfd(genom_client h);
const struct genom_service_info *
			genom_realsense_client_service_info(genom_client h,
				int rqstid);
int			genom_realsense_client_done(genom_client h, int rqstid);
genom_event		genom_realsense_client_wait(genom_client h, int rqstid);
genom_event		genom_realsense_client_clean(genom_client h,
				int rqstid);
genom_event		genom_realsense_client_abort(genom_client h,
                                int rqstid);
genom_event		genom_realsense_client_doevents(genom_client h);
char *			genom_realsense_client_json_error(genom_client h,
				genom_event e, const void *detail);

/* abort_activity */
typedef void (*realsense_abort_activity_cb)(
  genom_client h,
  int rqstid,
  int done,
  genom_event report,
  struct genom_realsense_abort_activity_output *out,
  const void *exdetail,
  void *cb_data);

genom_event genom_realsense_client_abort_activity_rqst(
  genom_client h,
  const struct genom_realsense_abort_activity_input *in,
  realsense_abort_activity_cb sentcb, realsense_abort_activity_cb donecb,
  void *cb_data, int *rqstid);

genom_event genom_realsense_client_abort_activity_result(
  genom_client h, int rqstid, genom_event *report,
  struct genom_realsense_abort_activity_output **out,
  void **exdetail);

void	genom_realsense_client_abort_activity_init_input(
  struct genom_realsense_abort_activity_input *input);
void	genom_realsense_client_abort_activity_init_output(
  struct genom_realsense_abort_activity_output *output);
void	genom_realsense_client_abort_activity_fini_input(
  struct genom_realsense_abort_activity_input *input);
void	genom_realsense_client_abort_activity_fini_output(
  struct genom_realsense_abort_activity_output *output);

int	genom_realsense_client_abort_activity_json_scan(
  struct genom_realsense_abort_activity_input *in,
  const char *json, char **endptr);
int	genom_realsense_client_abort_activity_json_print(
  char **json, const struct genom_realsense_abort_activity_output *out);

/* connect_port */
typedef void (*realsense_connect_port_cb)(
  genom_client h,
  int rqstid,
  int done,
  genom_event report,
  struct genom_realsense_connect_port_output *out,
  const void *exdetail,
  void *cb_data);

genom_event genom_realsense_client_connect_port_rqst(
  genom_client h,
  const struct genom_realsense_connect_port_input *in,
  realsense_connect_port_cb sentcb, realsense_connect_port_cb donecb,
  void *cb_data, int *rqstid);

genom_event genom_realsense_client_connect_port_result(
  genom_client h, int rqstid, genom_event *report,
  struct genom_realsense_connect_port_output **out,
  void **exdetail);

void	genom_realsense_client_connect_port_init_input(
  struct genom_realsense_connect_port_input *input);
void	genom_realsense_client_connect_port_init_output(
  struct genom_realsense_connect_port_output *output);
void	genom_realsense_client_connect_port_fini_input(
  struct genom_realsense_connect_port_input *input);
void	genom_realsense_client_connect_port_fini_output(
  struct genom_realsense_connect_port_output *output);

int	genom_realsense_client_connect_port_json_scan(
  struct genom_realsense_connect_port_input *in,
  const char *json, char **endptr);
int	genom_realsense_client_connect_port_json_print(
  char **json, const struct genom_realsense_connect_port_output *out);

/* connect_service */
typedef void (*realsense_connect_service_cb)(
  genom_client h,
  int rqstid,
  int done,
  genom_event report,
  struct genom_realsense_connect_service_output *out,
  const void *exdetail,
  void *cb_data);

genom_event genom_realsense_client_connect_service_rqst(
  genom_client h,
  const struct genom_realsense_connect_service_input *in,
  realsense_connect_service_cb sentcb, realsense_connect_service_cb donecb,
  void *cb_data, int *rqstid);

genom_event genom_realsense_client_connect_service_result(
  genom_client h, int rqstid, genom_event *report,
  struct genom_realsense_connect_service_output **out,
  void **exdetail);

void	genom_realsense_client_connect_service_init_input(
  struct genom_realsense_connect_service_input *input);
void	genom_realsense_client_connect_service_init_output(
  struct genom_realsense_connect_service_output *output);
void	genom_realsense_client_connect_service_fini_input(
  struct genom_realsense_connect_service_input *input);
void	genom_realsense_client_connect_service_fini_output(
  struct genom_realsense_connect_service_output *output);

int	genom_realsense_client_connect_service_json_scan(
  struct genom_realsense_connect_service_input *in,
  const char *json, char **endptr);
int	genom_realsense_client_connect_service_json_print(
  char **json, const struct genom_realsense_connect_service_output *out);

/* kill */
typedef void (*realsense_kill_cb)(
  genom_client h,
  int rqstid,
  int done,
  genom_event report,
  struct genom_realsense_kill_output *out,
  const void *exdetail,
  void *cb_data);

genom_event genom_realsense_client_kill_rqst(
  genom_client h,
  const struct genom_realsense_kill_input *in,
  realsense_kill_cb sentcb, realsense_kill_cb donecb,
  void *cb_data, int *rqstid);

genom_event genom_realsense_client_kill_result(
  genom_client h, int rqstid, genom_event *report,
  struct genom_realsense_kill_output **out,
  void **exdetail);

void	genom_realsense_client_kill_init_input(
  struct genom_realsense_kill_input *input);
void	genom_realsense_client_kill_init_output(
  struct genom_realsense_kill_output *output);
void	genom_realsense_client_kill_fini_input(
  struct genom_realsense_kill_input *input);
void	genom_realsense_client_kill_fini_output(
  struct genom_realsense_kill_output *output);

int	genom_realsense_client_kill_json_scan(
  struct genom_realsense_kill_input *in,
  const char *json, char **endptr);
int	genom_realsense_client_kill_json_print(
  char **json, const struct genom_realsense_kill_output *out);

/* publish */
typedef void (*realsense_publish_cb)(
  genom_client h,
  int rqstid,
  int done,
  genom_event report,
  struct genom_realsense_publish_output *out,
  const void *exdetail,
  void *cb_data);

genom_event genom_realsense_client_publish_rqst(
  genom_client h,
  const struct genom_realsense_publish_input *in,
  realsense_publish_cb sentcb, realsense_publish_cb donecb,
  void *cb_data, int *rqstid);

genom_event genom_realsense_client_publish_result(
  genom_client h, int rqstid, genom_event *report,
  struct genom_realsense_publish_output **out,
  void **exdetail);

void	genom_realsense_client_publish_init_input(
  struct genom_realsense_publish_input *input);
void	genom_realsense_client_publish_init_output(
  struct genom_realsense_publish_output *output);
void	genom_realsense_client_publish_fini_input(
  struct genom_realsense_publish_input *input);
void	genom_realsense_client_publish_fini_output(
  struct genom_realsense_publish_output *output);

int	genom_realsense_client_publish_json_scan(
  struct genom_realsense_publish_input *in,
  const char *json, char **endptr);
int	genom_realsense_client_publish_json_print(
  char **json, const struct genom_realsense_publish_output *out);

/* unpublish */
typedef void (*realsense_unpublish_cb)(
  genom_client h,
  int rqstid,
  int done,
  genom_event report,
  struct genom_realsense_unpublish_output *out,
  const void *exdetail,
  void *cb_data);

genom_event genom_realsense_client_unpublish_rqst(
  genom_client h,
  const struct genom_realsense_unpublish_input *in,
  realsense_unpublish_cb sentcb, realsense_unpublish_cb donecb,
  void *cb_data, int *rqstid);

genom_event genom_realsense_client_unpublish_result(
  genom_client h, int rqstid, genom_event *report,
  struct genom_realsense_unpublish_output **out,
  void **exdetail);

void	genom_realsense_client_unpublish_init_input(
  struct genom_realsense_unpublish_input *input);
void	genom_realsense_client_unpublish_init_output(
  struct genom_realsense_unpublish_output *output);
void	genom_realsense_client_unpublish_fini_input(
  struct genom_realsense_unpublish_input *input);
void	genom_realsense_client_unpublish_fini_output(
  struct genom_realsense_unpublish_output *output);

int	genom_realsense_client_unpublish_json_scan(
  struct genom_realsense_unpublish_input *in,
  const char *json, char **endptr);
int	genom_realsense_client_unpublish_json_print(
  char **json, const struct genom_realsense_unpublish_output *out);

/* jpeg */
typedef void (*realsense_jpeg_cb)(
  genom_client h,
  int rqstid,
  int done,
  genom_event report,
  struct genom_realsense_jpeg_output *out,
  const void *exdetail,
  void *cb_data);

genom_event genom_realsense_client_jpeg_rqst(
  genom_client h,
  const struct genom_realsense_jpeg_input *in,
  realsense_jpeg_cb sentcb, realsense_jpeg_cb donecb,
  void *cb_data, int *rqstid);

genom_event genom_realsense_client_jpeg_result(
  genom_client h, int rqstid, genom_event *report,
  struct genom_realsense_jpeg_output **out,
  void **exdetail);

void	genom_realsense_client_jpeg_init_input(
  struct genom_realsense_jpeg_input *input);
void	genom_realsense_client_jpeg_init_output(
  struct genom_realsense_jpeg_output *output);
void	genom_realsense_client_jpeg_fini_input(
  struct genom_realsense_jpeg_input *input);
void	genom_realsense_client_jpeg_fini_output(
  struct genom_realsense_jpeg_output *output);

int	genom_realsense_client_jpeg_json_scan(
  struct genom_realsense_jpeg_input *in,
  const char *json, char **endptr);
int	genom_realsense_client_jpeg_json_print(
  char **json, const struct genom_realsense_jpeg_output *out);

/* record_mpeg */
typedef void (*realsense_record_mpeg_cb)(
  genom_client h,
  int rqstid,
  int done,
  genom_event report,
  struct genom_realsense_record_mpeg_output *out,
  const void *exdetail,
  void *cb_data);

genom_event genom_realsense_client_record_mpeg_rqst(
  genom_client h,
  const struct genom_realsense_record_mpeg_input *in,
  realsense_record_mpeg_cb sentcb, realsense_record_mpeg_cb donecb,
  void *cb_data, int *rqstid);

genom_event genom_realsense_client_record_mpeg_result(
  genom_client h, int rqstid, genom_event *report,
  struct genom_realsense_record_mpeg_output **out,
  void **exdetail);

void	genom_realsense_client_record_mpeg_init_input(
  struct genom_realsense_record_mpeg_input *input);
void	genom_realsense_client_record_mpeg_init_output(
  struct genom_realsense_record_mpeg_output *output);
void	genom_realsense_client_record_mpeg_fini_input(
  struct genom_realsense_record_mpeg_input *input);
void	genom_realsense_client_record_mpeg_fini_output(
  struct genom_realsense_record_mpeg_output *output);

int	genom_realsense_client_record_mpeg_json_scan(
  struct genom_realsense_record_mpeg_input *in,
  const char *json, char **endptr);
int	genom_realsense_client_record_mpeg_json_print(
  char **json, const struct genom_realsense_record_mpeg_output *out);

/* cancel */
typedef void (*realsense_cancel_cb)(
  genom_client h,
  int rqstid,
  int done,
  genom_event report,
  struct genom_realsense_cancel_output *out,
  const void *exdetail,
  void *cb_data);

genom_event genom_realsense_client_cancel_rqst(
  genom_client h,
  const struct genom_realsense_cancel_input *in,
  realsense_cancel_cb sentcb, realsense_cancel_cb donecb,
  void *cb_data, int *rqstid);

genom_event genom_realsense_client_cancel_result(
  genom_client h, int rqstid, genom_event *report,
  struct genom_realsense_cancel_output **out,
  void **exdetail);

void	genom_realsense_client_cancel_init_input(
  struct genom_realsense_cancel_input *input);
void	genom_realsense_client_cancel_init_output(
  struct genom_realsense_cancel_output *output);
void	genom_realsense_client_cancel_fini_input(
  struct genom_realsense_cancel_input *input);
void	genom_realsense_client_cancel_fini_output(
  struct genom_realsense_cancel_output *output);

int	genom_realsense_client_cancel_json_scan(
  struct genom_realsense_cancel_input *in,
  const char *json, char **endptr);
int	genom_realsense_client_cancel_json_print(
  char **json, const struct genom_realsense_cancel_output *out);

/* status */
typedef void (*realsense_status_cb)(
  genom_client h,
  int rqstid,
  int done,
  genom_event report,
  struct genom_realsense_status_output *out,
  const void *exdetail,
  void *cb_data);

genom_event genom_realsense_client_status_rqst(
  genom_client h,
  const struct genom_realsense_status_input *in,
  realsense_status_cb sentcb, realsense_status_cb donecb,
  void *cb_data, int *rqstid);

genom_event genom_realsense_client_status_result(
  genom_client h, int rqstid, genom_event *report,
  struct genom_realsense_status_output **out,
  void **exdetail);

void	genom_realsense_client_status_init_input(
  struct genom_realsense_status_input *input);
void	genom_realsense_client_status_init_output(
  struct genom_realsense_status_output *output);
void	genom_realsense_client_status_fini_input(
  struct genom_realsense_status_input *input);
void	genom_realsense_client_status_fini_output(
  struct genom_realsense_status_output *output);

int	genom_realsense_client_status_json_scan(
  struct genom_realsense_status_input *in,
  const char *json, char **endptr);
int	genom_realsense_client_status_json_print(
  char **json, const struct genom_realsense_status_output *out);

/* get_imu_noise */
typedef void (*realsense_get_imu_noise_cb)(
  genom_client h,
  int rqstid,
  int done,
  genom_event report,
  struct genom_realsense_get_imu_noise_output *out,
  const void *exdetail,
  void *cb_data);

genom_event genom_realsense_client_get_imu_noise_rqst(
  genom_client h,
  const struct genom_realsense_get_imu_noise_input *in,
  realsense_get_imu_noise_cb sentcb, realsense_get_imu_noise_cb donecb,
  void *cb_data, int *rqstid);

genom_event genom_realsense_client_get_imu_noise_result(
  genom_client h, int rqstid, genom_event *report,
  struct genom_realsense_get_imu_noise_output **out,
  void **exdetail);

void	genom_realsense_client_get_imu_noise_init_input(
  struct genom_realsense_get_imu_noise_input *input);
void	genom_realsense_client_get_imu_noise_init_output(
  struct genom_realsense_get_imu_noise_output *output);
void	genom_realsense_client_get_imu_noise_fini_input(
  struct genom_realsense_get_imu_noise_input *input);
void	genom_realsense_client_get_imu_noise_fini_output(
  struct genom_realsense_get_imu_noise_output *output);

int	genom_realsense_client_get_imu_noise_json_scan(
  struct genom_realsense_get_imu_noise_input *in,
  const char *json, char **endptr);
int	genom_realsense_client_get_imu_noise_json_print(
  char **json, const struct genom_realsense_get_imu_noise_output *out);

/* set_imu_noise */
typedef void (*realsense_set_imu_noise_cb)(
  genom_client h,
  int rqstid,
  int done,
  genom_event report,
  struct genom_realsense_set_imu_noise_output *out,
  const void *exdetail,
  void *cb_data);

genom_event genom_realsense_client_set_imu_noise_rqst(
  genom_client h,
  const struct genom_realsense_set_imu_noise_input *in,
  realsense_set_imu_noise_cb sentcb, realsense_set_imu_noise_cb donecb,
  void *cb_data, int *rqstid);

genom_event genom_realsense_client_set_imu_noise_result(
  genom_client h, int rqstid, genom_event *report,
  struct genom_realsense_set_imu_noise_output **out,
  void **exdetail);

void	genom_realsense_client_set_imu_noise_init_input(
  struct genom_realsense_set_imu_noise_input *input);
void	genom_realsense_client_set_imu_noise_init_output(
  struct genom_realsense_set_imu_noise_output *output);
void	genom_realsense_client_set_imu_noise_fini_input(
  struct genom_realsense_set_imu_noise_input *input);
void	genom_realsense_client_set_imu_noise_fini_output(
  struct genom_realsense_set_imu_noise_output *output);

int	genom_realsense_client_set_imu_noise_json_scan(
  struct genom_realsense_set_imu_noise_input *in,
  const char *json, char **endptr);
int	genom_realsense_client_set_imu_noise_json_print(
  char **json, const struct genom_realsense_set_imu_noise_output *out);

/* get_streams */
typedef void (*realsense_get_streams_cb)(
  genom_client h,
  int rqstid,
  int done,
  genom_event report,
  struct genom_realsense_get_streams_output *out,
  const void *exdetail,
  void *cb_data);

genom_event genom_realsense_client_get_streams_rqst(
  genom_client h,
  const struct genom_realsense_get_streams_input *in,
  realsense_get_streams_cb sentcb, realsense_get_streams_cb donecb,
  void *cb_data, int *rqstid);

genom_event genom_realsense_client_get_streams_result(
  genom_client h, int rqstid, genom_event *report,
  struct genom_realsense_get_streams_output **out,
  void **exdetail);

void	genom_realsense_client_get_streams_init_input(
  struct genom_realsense_get_streams_input *input);
void	genom_realsense_client_get_streams_init_output(
  struct genom_realsense_get_streams_output *output);
void	genom_realsense_client_get_streams_fini_input(
  struct genom_realsense_get_streams_input *input);
void	genom_realsense_client_get_streams_fini_output(
  struct genom_realsense_get_streams_output *output);

int	genom_realsense_client_get_streams_json_scan(
  struct genom_realsense_get_streams_input *in,
  const char *json, char **endptr);
int	genom_realsense_client_get_streams_json_print(
  char **json, const struct genom_realsense_get_streams_output *out);

/* get_stream_indices */
typedef void (*realsense_get_stream_indices_cb)(
  genom_client h,
  int rqstid,
  int done,
  genom_event report,
  struct genom_realsense_get_stream_indices_output *out,
  const void *exdetail,
  void *cb_data);

genom_event genom_realsense_client_get_stream_indices_rqst(
  genom_client h,
  const struct genom_realsense_get_stream_indices_input *in,
  realsense_get_stream_indices_cb sentcb, realsense_get_stream_indices_cb donecb,
  void *cb_data, int *rqstid);

genom_event genom_realsense_client_get_stream_indices_result(
  genom_client h, int rqstid, genom_event *report,
  struct genom_realsense_get_stream_indices_output **out,
  void **exdetail);

void	genom_realsense_client_get_stream_indices_init_input(
  struct genom_realsense_get_stream_indices_input *input);
void	genom_realsense_client_get_stream_indices_init_output(
  struct genom_realsense_get_stream_indices_output *output);
void	genom_realsense_client_get_stream_indices_fini_input(
  struct genom_realsense_get_stream_indices_input *input);
void	genom_realsense_client_get_stream_indices_fini_output(
  struct genom_realsense_get_stream_indices_output *output);

int	genom_realsense_client_get_stream_indices_json_scan(
  struct genom_realsense_get_stream_indices_input *in,
  const char *json, char **endptr);
int	genom_realsense_client_get_stream_indices_json_print(
  char **json, const struct genom_realsense_get_stream_indices_output *out);

/* get_stream_fps */
typedef void (*realsense_get_stream_fps_cb)(
  genom_client h,
  int rqstid,
  int done,
  genom_event report,
  struct genom_realsense_get_stream_fps_output *out,
  const void *exdetail,
  void *cb_data);

genom_event genom_realsense_client_get_stream_fps_rqst(
  genom_client h,
  const struct genom_realsense_get_stream_fps_input *in,
  realsense_get_stream_fps_cb sentcb, realsense_get_stream_fps_cb donecb,
  void *cb_data, int *rqstid);

genom_event genom_realsense_client_get_stream_fps_result(
  genom_client h, int rqstid, genom_event *report,
  struct genom_realsense_get_stream_fps_output **out,
  void **exdetail);

void	genom_realsense_client_get_stream_fps_init_input(
  struct genom_realsense_get_stream_fps_input *input);
void	genom_realsense_client_get_stream_fps_init_output(
  struct genom_realsense_get_stream_fps_output *output);
void	genom_realsense_client_get_stream_fps_fini_input(
  struct genom_realsense_get_stream_fps_input *input);
void	genom_realsense_client_get_stream_fps_fini_output(
  struct genom_realsense_get_stream_fps_output *output);

int	genom_realsense_client_get_stream_fps_json_scan(
  struct genom_realsense_get_stream_fps_input *in,
  const char *json, char **endptr);
int	genom_realsense_client_get_stream_fps_json_print(
  char **json, const struct genom_realsense_get_stream_fps_output *out);

/* get_video_stream_formats */
typedef void (*realsense_get_video_stream_formats_cb)(
  genom_client h,
  int rqstid,
  int done,
  genom_event report,
  struct genom_realsense_get_video_stream_formats_output *out,
  const void *exdetail,
  void *cb_data);

genom_event genom_realsense_client_get_video_stream_formats_rqst(
  genom_client h,
  const struct genom_realsense_get_video_stream_formats_input *in,
  realsense_get_video_stream_formats_cb sentcb, realsense_get_video_stream_formats_cb donecb,
  void *cb_data, int *rqstid);

genom_event genom_realsense_client_get_video_stream_formats_result(
  genom_client h, int rqstid, genom_event *report,
  struct genom_realsense_get_video_stream_formats_output **out,
  void **exdetail);

void	genom_realsense_client_get_video_stream_formats_init_input(
  struct genom_realsense_get_video_stream_formats_input *input);
void	genom_realsense_client_get_video_stream_formats_init_output(
  struct genom_realsense_get_video_stream_formats_output *output);
void	genom_realsense_client_get_video_stream_formats_fini_input(
  struct genom_realsense_get_video_stream_formats_input *input);
void	genom_realsense_client_get_video_stream_formats_fini_output(
  struct genom_realsense_get_video_stream_formats_output *output);

int	genom_realsense_client_get_video_stream_formats_json_scan(
  struct genom_realsense_get_video_stream_formats_input *in,
  const char *json, char **endptr);
int	genom_realsense_client_get_video_stream_formats_json_print(
  char **json, const struct genom_realsense_get_video_stream_formats_output *out);

/* get_depth_stream_formats */
typedef void (*realsense_get_depth_stream_formats_cb)(
  genom_client h,
  int rqstid,
  int done,
  genom_event report,
  struct genom_realsense_get_depth_stream_formats_output *out,
  const void *exdetail,
  void *cb_data);

genom_event genom_realsense_client_get_depth_stream_formats_rqst(
  genom_client h,
  const struct genom_realsense_get_depth_stream_formats_input *in,
  realsense_get_depth_stream_formats_cb sentcb, realsense_get_depth_stream_formats_cb donecb,
  void *cb_data, int *rqstid);

genom_event genom_realsense_client_get_depth_stream_formats_result(
  genom_client h, int rqstid, genom_event *report,
  struct genom_realsense_get_depth_stream_formats_output **out,
  void **exdetail);

void	genom_realsense_client_get_depth_stream_formats_init_input(
  struct genom_realsense_get_depth_stream_formats_input *input);
void	genom_realsense_client_get_depth_stream_formats_init_output(
  struct genom_realsense_get_depth_stream_formats_output *output);
void	genom_realsense_client_get_depth_stream_formats_fini_input(
  struct genom_realsense_get_depth_stream_formats_input *input);
void	genom_realsense_client_get_depth_stream_formats_fini_output(
  struct genom_realsense_get_depth_stream_formats_output *output);

int	genom_realsense_client_get_depth_stream_formats_json_scan(
  struct genom_realsense_get_depth_stream_formats_input *in,
  const char *json, char **endptr);
int	genom_realsense_client_get_depth_stream_formats_json_print(
  char **json, const struct genom_realsense_get_depth_stream_formats_output *out);

/* get_video_stream_sizes */
typedef void (*realsense_get_video_stream_sizes_cb)(
  genom_client h,
  int rqstid,
  int done,
  genom_event report,
  struct genom_realsense_get_video_stream_sizes_output *out,
  const void *exdetail,
  void *cb_data);

genom_event genom_realsense_client_get_video_stream_sizes_rqst(
  genom_client h,
  const struct genom_realsense_get_video_stream_sizes_input *in,
  realsense_get_video_stream_sizes_cb sentcb, realsense_get_video_stream_sizes_cb donecb,
  void *cb_data, int *rqstid);

genom_event genom_realsense_client_get_video_stream_sizes_result(
  genom_client h, int rqstid, genom_event *report,
  struct genom_realsense_get_video_stream_sizes_output **out,
  void **exdetail);

void	genom_realsense_client_get_video_stream_sizes_init_input(
  struct genom_realsense_get_video_stream_sizes_input *input);
void	genom_realsense_client_get_video_stream_sizes_init_output(
  struct genom_realsense_get_video_stream_sizes_output *output);
void	genom_realsense_client_get_video_stream_sizes_fini_input(
  struct genom_realsense_get_video_stream_sizes_input *input);
void	genom_realsense_client_get_video_stream_sizes_fini_output(
  struct genom_realsense_get_video_stream_sizes_output *output);

int	genom_realsense_client_get_video_stream_sizes_json_scan(
  struct genom_realsense_get_video_stream_sizes_input *in,
  const char *json, char **endptr);
int	genom_realsense_client_get_video_stream_sizes_json_print(
  char **json, const struct genom_realsense_get_video_stream_sizes_output *out);

/* get_depth_stream_sizes */
typedef void (*realsense_get_depth_stream_sizes_cb)(
  genom_client h,
  int rqstid,
  int done,
  genom_event report,
  struct genom_realsense_get_depth_stream_sizes_output *out,
  const void *exdetail,
  void *cb_data);

genom_event genom_realsense_client_get_depth_stream_sizes_rqst(
  genom_client h,
  const struct genom_realsense_get_depth_stream_sizes_input *in,
  realsense_get_depth_stream_sizes_cb sentcb, realsense_get_depth_stream_sizes_cb donecb,
  void *cb_data, int *rqstid);

genom_event genom_realsense_client_get_depth_stream_sizes_result(
  genom_client h, int rqstid, genom_event *report,
  struct genom_realsense_get_depth_stream_sizes_output **out,
  void **exdetail);

void	genom_realsense_client_get_depth_stream_sizes_init_input(
  struct genom_realsense_get_depth_stream_sizes_input *input);
void	genom_realsense_client_get_depth_stream_sizes_init_output(
  struct genom_realsense_get_depth_stream_sizes_output *output);
void	genom_realsense_client_get_depth_stream_sizes_fini_input(
  struct genom_realsense_get_depth_stream_sizes_input *input);
void	genom_realsense_client_get_depth_stream_sizes_fini_output(
  struct genom_realsense_get_depth_stream_sizes_output *output);

int	genom_realsense_client_get_depth_stream_sizes_json_scan(
  struct genom_realsense_get_depth_stream_sizes_input *in,
  const char *json, char **endptr);
int	genom_realsense_client_get_depth_stream_sizes_json_print(
  char **json, const struct genom_realsense_get_depth_stream_sizes_output *out);

/* stream_video */
typedef void (*realsense_stream_video_cb)(
  genom_client h,
  int rqstid,
  int done,
  genom_event report,
  struct genom_realsense_stream_video_output *out,
  const void *exdetail,
  void *cb_data);

genom_event genom_realsense_client_stream_video_rqst(
  genom_client h,
  const struct genom_realsense_stream_video_input *in,
  realsense_stream_video_cb sentcb, realsense_stream_video_cb donecb,
  void *cb_data, int *rqstid);

genom_event genom_realsense_client_stream_video_result(
  genom_client h, int rqstid, genom_event *report,
  struct genom_realsense_stream_video_output **out,
  void **exdetail);

void	genom_realsense_client_stream_video_init_input(
  struct genom_realsense_stream_video_input *input);
void	genom_realsense_client_stream_video_init_output(
  struct genom_realsense_stream_video_output *output);
void	genom_realsense_client_stream_video_fini_input(
  struct genom_realsense_stream_video_input *input);
void	genom_realsense_client_stream_video_fini_output(
  struct genom_realsense_stream_video_output *output);

int	genom_realsense_client_stream_video_json_scan(
  struct genom_realsense_stream_video_input *in,
  const char *json, char **endptr);
int	genom_realsense_client_stream_video_json_print(
  char **json, const struct genom_realsense_stream_video_output *out);

/* stream_depth */
typedef void (*realsense_stream_depth_cb)(
  genom_client h,
  int rqstid,
  int done,
  genom_event report,
  struct genom_realsense_stream_depth_output *out,
  const void *exdetail,
  void *cb_data);

genom_event genom_realsense_client_stream_depth_rqst(
  genom_client h,
  const struct genom_realsense_stream_depth_input *in,
  realsense_stream_depth_cb sentcb, realsense_stream_depth_cb donecb,
  void *cb_data, int *rqstid);

genom_event genom_realsense_client_stream_depth_result(
  genom_client h, int rqstid, genom_event *report,
  struct genom_realsense_stream_depth_output **out,
  void **exdetail);

void	genom_realsense_client_stream_depth_init_input(
  struct genom_realsense_stream_depth_input *input);
void	genom_realsense_client_stream_depth_init_output(
  struct genom_realsense_stream_depth_output *output);
void	genom_realsense_client_stream_depth_fini_input(
  struct genom_realsense_stream_depth_input *input);
void	genom_realsense_client_stream_depth_fini_output(
  struct genom_realsense_stream_depth_output *output);

int	genom_realsense_client_stream_depth_json_scan(
  struct genom_realsense_stream_depth_input *in,
  const char *json, char **endptr);
int	genom_realsense_client_stream_depth_json_print(
  char **json, const struct genom_realsense_stream_depth_output *out);

/* stream_motion */
typedef void (*realsense_stream_motion_cb)(
  genom_client h,
  int rqstid,
  int done,
  genom_event report,
  struct genom_realsense_stream_motion_output *out,
  const void *exdetail,
  void *cb_data);

genom_event genom_realsense_client_stream_motion_rqst(
  genom_client h,
  const struct genom_realsense_stream_motion_input *in,
  realsense_stream_motion_cb sentcb, realsense_stream_motion_cb donecb,
  void *cb_data, int *rqstid);

genom_event genom_realsense_client_stream_motion_result(
  genom_client h, int rqstid, genom_event *report,
  struct genom_realsense_stream_motion_output **out,
  void **exdetail);

void	genom_realsense_client_stream_motion_init_input(
  struct genom_realsense_stream_motion_input *input);
void	genom_realsense_client_stream_motion_init_output(
  struct genom_realsense_stream_motion_output *output);
void	genom_realsense_client_stream_motion_fini_input(
  struct genom_realsense_stream_motion_input *input);
void	genom_realsense_client_stream_motion_fini_output(
  struct genom_realsense_stream_motion_output *output);

int	genom_realsense_client_stream_motion_json_scan(
  struct genom_realsense_stream_motion_input *in,
  const char *json, char **endptr);
int	genom_realsense_client_stream_motion_json_print(
  char **json, const struct genom_realsense_stream_motion_output *out);



/* --- Ports --------------------------------------------------------------- */

/* genom_state */
#line 78 "/opt/openrobots/share/genom/templates/common/genom.gen"
genom_state_component *
  genom_realsense_client_genom_state_data(
    genom_client h
  );
#line 78 "/opt/openrobots/share/genom/templates/common/genom.gen"
genom_event genom_realsense_client_genom_state_read(
  genom_client h,
  genom_state_component *data);
#line 78 "/opt/openrobots/share/genom/templates/common/genom.gen"
genom_event genom_realsense_client_genom_state_port(
  genom_client h,
  genom_state_component *data)
  __attribute__((deprecated(
                   "use genom_realsense_client_genom_state_read instead")));

/* image */
#line 60 "/opt/openrobots/share/idl/camera/camera.gen"
or_image_bank *
  genom_realsense_client_image_data(
    genom_client h, const char *name
  );
#line 60 "/opt/openrobots/share/idl/camera/camera.gen"
genom_event genom_realsense_client_image_read(
  genom_client h,
  const char *name,
  or_image_bank *data);
#line 60 "/opt/openrobots/share/idl/camera/camera.gen"
genom_event genom_realsense_client_image_port(
  genom_client h,
  const char *name,
  or_image_bank *data)
  __attribute__((deprecated(
                   "use genom_realsense_client_image_read instead")));

/* accel */
#line 51 "/local/robotpkg/var/tmp/robotpkg/hardware/realsense-genom3/work/realsense-genom3-2.0/realsense.gen"
or_pose_estimator_state *
  genom_realsense_client_accel_data(
    genom_client h
  );
#line 51 "/local/robotpkg/var/tmp/robotpkg/hardware/realsense-genom3/work/realsense-genom3-2.0/realsense.gen"
genom_event genom_realsense_client_accel_read(
  genom_client h,
  or_pose_estimator_state *data);
#line 51 "/local/robotpkg/var/tmp/robotpkg/hardware/realsense-genom3/work/realsense-genom3-2.0/realsense.gen"
genom_event genom_realsense_client_accel_port(
  genom_client h,
  or_pose_estimator_state *data)
  __attribute__((deprecated(
                   "use genom_realsense_client_accel_read instead")));

/* gyro */
#line 52 "/local/robotpkg/var/tmp/robotpkg/hardware/realsense-genom3/work/realsense-genom3-2.0/realsense.gen"
or_pose_estimator_state *
  genom_realsense_client_gyro_data(
    genom_client h
  );
#line 52 "/local/robotpkg/var/tmp/robotpkg/hardware/realsense-genom3/work/realsense-genom3-2.0/realsense.gen"
genom_event genom_realsense_client_gyro_read(
  genom_client h,
  or_pose_estimator_state *data);
#line 52 "/local/robotpkg/var/tmp/robotpkg/hardware/realsense-genom3/work/realsense-genom3-2.0/realsense.gen"
genom_event genom_realsense_client_gyro_port(
  genom_client h,
  or_pose_estimator_state *data)
  __attribute__((deprecated(
                   "use genom_realsense_client_gyro_read instead")));



void	genom_realsense_client_genom_state_init_data(
  genom_state_component *data);
void	genom_realsense_client_genom_state_fini_data(
  genom_state_component *data);
int	genom_realsense_client_genom_state_json_print(char **json,
  const genom_state_component *data);
void	genom_realsense_client_image_init_data(
  or_image_bank *data);
void	genom_realsense_client_image_fini_data(
  or_image_bank *data);
int	genom_realsense_client_image_json_print(char **json,
  const or_image_bank *data);
void	genom_realsense_client_accel_init_data(
  or_pose_estimator_state *data);
void	genom_realsense_client_accel_fini_data(
  or_pose_estimator_state *data);
int	genom_realsense_client_accel_json_print(char **json,
  const or_pose_estimator_state *data);
void	genom_realsense_client_gyro_init_data(
  or_pose_estimator_state *data);
void	genom_realsense_client_gyro_fini_data(
  or_pose_estimator_state *data);
int	genom_realsense_client_gyro_json_print(char **json,
  const or_pose_estimator_state *data);



/* --- Data ---------------------------------------------------------------- */

extern const struct genom_client_info genom_realsense_client_info;

extern const struct genom_service_info *
			genom_realsense_client_abort_activity_info;
extern const struct genom_service_info *
			genom_realsense_client_connect_port_info;
extern const struct genom_service_info *
			genom_realsense_client_connect_service_info;
extern const struct genom_service_info *
			genom_realsense_client_kill_info;
extern const struct genom_service_info *
			genom_realsense_client_publish_info;
extern const struct genom_service_info *
			genom_realsense_client_unpublish_info;
extern const struct genom_service_info *
			genom_realsense_client_jpeg_info;
extern const struct genom_service_info *
			genom_realsense_client_record_mpeg_info;
extern const struct genom_service_info *
			genom_realsense_client_cancel_info;
extern const struct genom_service_info *
			genom_realsense_client_status_info;
extern const struct genom_service_info *
			genom_realsense_client_get_imu_noise_info;
extern const struct genom_service_info *
			genom_realsense_client_set_imu_noise_info;
extern const struct genom_service_info *
			genom_realsense_client_get_streams_info;
extern const struct genom_service_info *
			genom_realsense_client_get_stream_indices_info;
extern const struct genom_service_info *
			genom_realsense_client_get_stream_fps_info;
extern const struct genom_service_info *
			genom_realsense_client_get_video_stream_formats_info;
extern const struct genom_service_info *
			genom_realsense_client_get_depth_stream_formats_info;
extern const struct genom_service_info *
			genom_realsense_client_get_video_stream_sizes_info;
extern const struct genom_service_info *
			genom_realsense_client_get_depth_stream_sizes_info;
extern const struct genom_service_info *
			genom_realsense_client_stream_video_info;
extern const struct genom_service_info *
			genom_realsense_client_stream_depth_info;
extern const struct genom_service_info *
			genom_realsense_client_stream_motion_info;

extern const struct genom_port_info *
			genom_realsense_client_genom_state_info;
extern const struct genom_port_info *
			genom_realsense_client_image_info;
extern const struct genom_port_info *
			genom_realsense_client_accel_info;
extern const struct genom_port_info *
			genom_realsense_client_gyro_info;


#ifdef __cplusplus
}
#endif

#endif /* H_REALSENSE_CLIENT */
